# kyotocabinet::ProtoDB< STRMAP > Class Template Reference

Prototype implementation of file database with STL. More...

`#include <kcprotodb.h>`

List of all members.

## Classes

class | Cursor
| Cursor to indicate a record. More...
struct | TranLog
| Transaction log.

## Public Member Functions

| ProtoDB ()
| Default constructor.
virtual | ~ProtoDB ()
| Destructor.
virtual bool | accept (const char *kbuf, size_t ksiz, Visitor *visitor, bool writable=true)
| Accept a visitor to a record.
virtual bool | iterate (Visitor *visitor, bool writable=true)
| Iterate to accept a visitor for each record.
virtual Error | error () const
| Get the last happened error.
virtual void | set_error (Error::Code code, const char *message)
| Set the error information.
virtual bool | open (const std::string &path, uint32_t mode=OWRITER|OCREATE)
| Open a database file.
virtual bool | close ()
| Close the database file.
virtual bool | synchronize (bool hard=false, FileProcessor *proc=NULL)
| Synchronize updated contents with the file and the device.
virtual bool | begin_transaction (bool hard=false)
| Begin transaction.
virtual bool | begin_transaction_try (bool hard=false)
| Try to begin transaction.
virtual bool | end_transaction (bool commit=true)
| End transaction.
virtual bool | clear ()
| Remove all records.
virtual int64_t | count ()
| Get the number of records.
virtual int64_t | size ()
| Get the size of the database file.
virtual std::string | path ()
| Get the path of the database file.
virtual bool | status (std::map< std::string, std::string > *strmap)
| Get the miscellaneous status information.
virtual Cursor * | cursor ()
| Create a cursor object.

## Detailed Description

### template<class STRMAP>
class kyotocabinet::ProtoDB< STRMAP >

Prototype implementation of file database with STL.

Parameters:

  | STRMAP | a map compatible class of STL.

Note:
  The class ProtoHashDB is the instance using std::unordered_map. The class ProtoTreeDB is the instance using std::map.

## Constructor & Destructor Documentation

template<class STRMAP >

kyotocabinet::ProtoDB< STRMAP >::ProtoDB | ( |  | ) | `[explicit]`

Default constructor.

template<class STRMAP >

virtual kyotocabinet::ProtoDB< STRMAP >::~ProtoDB | ( |  | ) | `[virtual]`

Destructor.

Note:
  If the database is not closed, it is closed implicitly.

## Member Function Documentation

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::accept | ( | const char * | kbuf,
|  | size_t | ksiz,
|  | Visitor * | visitor,
|  | bool | writable = `true` |
| ) |  |  | `[virtual]`

Accept a visitor to a record.

Parameters:

  | kbuf | the pointer to the key region.
  | ksiz | the size of the key region.
  | visitor | a visitor object.
  | writable | true for writable operation, or false for read-only operation.

Returns:
  true on success, or false on failure.

Note:
  the operation for each record is performed atomically and other threads accessing the same record are blocked.

Implements kyotocabinet::DB.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::iterate | ( | Visitor * | visitor,
|  | bool | writable = `true` |
| ) |  |  | `[virtual]`

Iterate to accept a visitor for each record.

Parameters:

  | visitor | a visitor object.
  | writable | true for writable operation, or false for read-only operation.

Returns:
  true on success, or false on failure.

Note:
  the whole iteration is performed atomically and other threads are blocked.

Implements kyotocabinet::DB.

template<class STRMAP >

virtual Error kyotocabinet::ProtoDB< STRMAP >::error | ( |  | ) | const`[virtual]`

Get the last happened error.

Returns:
  the last happened error.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual void kyotocabinet::ProtoDB< STRMAP >::set_error | ( | Error::Code | code,
|  | const char * | message |
| ) |  |  | `[virtual]`

Set the error information.

Parameters:

  | code | an error code.
  | message | a supplement message.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::open | ( | const std::string & | path,
|  | uint32_t | mode = `OWRITER | OCREATE` |
| ) |  |  | `[virtual]`

Open a database file.

Parameters:

  | path | the path of a database file.

  mode

  the connection mode. FileDB::OWRITER as a writer, FileDB::OREADER as a reader. The following may be added to the writer mode by bitwise-or: FileDB::OCREATE, which means it creates a new database if the file does not exist, FileDB::OTRUNCATE, which means it creates a new database regardless if the file exists, FileDB::OAUTOTRAN, which means each updating operation is performed in implicit transaction, FileDB::OAUTOSYNC, which means each updating operation is followed by implicit synchronization with the file system. The following may be added to both of the reader mode and the writer mode by bitwise-or: FileDB::ONOLOCK, which means it opens the database file without file locking, FileDB::OTRYLOCK, which means locking is performed without blocking, FileDB::ONOREPAIR, which means the database file is not repaired implicitly even if file destruction is detected.

Returns:
  true on success, or false on failure.

Note:
  Every opened database must be closed by the FileDB::close method when it is no longer in use.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::close | ( |  | ) | `[virtual]`

Close the database file.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::synchronize | ( | bool | hard = `false`,
|  | FileProcessor * | proc = `NULL` |
| ) |  |  | `[virtual]`

Synchronize updated contents with the file and the device.

Parameters:

  | hard | true for physical synchronization with the device, or false for logical synchronization with the file system.
  | proc | a postprocessor object. If it is NULL, no postprocessing is performed.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::begin_transaction | ( | bool | hard = `false` | ) | `[virtual]`

Begin transaction.

Parameters:

  | hard | true for physical synchronization with the device, or false for logical synchronization with the file system.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::begin_transaction_try | ( | bool | hard = `false` | ) | `[virtual]`

Try to begin transaction.

Parameters:

  | hard | true for physical synchronization with the device, or false for logical synchronization with the file system.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::end_transaction | ( | bool | commit = `true` | ) | `[virtual]`

End transaction.

Parameters:

  | commit | true to commit the transaction, or false to abort the transaction.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::clear | ( |  | ) | `[virtual]`

Remove all records.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::DB.

template<class STRMAP >

virtual int64_t kyotocabinet::ProtoDB< STRMAP >::count | ( |  | ) | `[virtual]`

Get the number of records.

Returns:
  the number of records, or -1 on failure.

Implements kyotocabinet::DB.

template<class STRMAP >

virtual int64_t kyotocabinet::ProtoDB< STRMAP >::size | ( |  | ) | `[virtual]`

Get the size of the database file.

Returns:
  the size of the database file in bytes, or -1 on failure.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual std::string kyotocabinet::ProtoDB< STRMAP >::path | ( |  | ) | `[virtual]`

Get the path of the database file.

Returns:
  the path of the database file, or an empty string on failure.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual bool kyotocabinet::ProtoDB< STRMAP >::status | ( | std::map< std::string, std::string > * | strmap | ) | `[virtual]`

Get the miscellaneous status information.

Parameters:

  | strmap | a string map to contain the result.

Returns:
  true on success, or false on failure.

Implements kyotocabinet::FileDB.

template<class STRMAP >

virtual Cursor* kyotocabinet::ProtoDB< STRMAP >::cursor | ( |  | ) | `[virtual]`

Create a cursor object.

Returns:
  the return value is the created cursor object.

Note:
  Because the object of the return value is allocated by the constructor, it should be released with the delete operator when it is no longer in use.

Implements kyotocabinet::FileDB.